/*
 * Copyright (c) 2005, 2006, 2007  by KoanLogic <http://www.koanlogic.com>
 * All rights reserved.
 *
 * $Id: msgchan.h,v 1.1 2007/11/11 18:01:12 tat Exp $
 */
#ifndef _KLAPP_MSGCHAN_T_
#define _KLAPP_MSGCHAN_T_
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <unistd.h>
#include <klone/klone.h>

struct msgchan_s;
typedef struct msgchan_s msgchan_t;

/* handler function prototype */
typedef void (*msgchan_handler_t)(msgchan_t *mc, void *arg, const char *id, 
        const char *data);

/* periodic handler function prototype */
typedef void (*msgchan_periodic_t)(msgchan_t *mc, void *arg, struct timeval *);

int msgchan_write(msgchan_t *mc, const char *buf, size_t sz);
int msgchan_printf(msgchan_t *mc, const char *fmt, ...);
int msgchan_read(msgchan_t *mc, char *buf, size_t sz, struct timeval *tv);
int msgchan_register(msgchan_t *mc, const char *id, msgchan_handler_t function,
        void *arg);
int msgchan_register_periodic(msgchan_t *mc, msgchan_periodic_t function,
        void *arg);
int msgchan_unregister_periodic(msgchan_t *mc, msgchan_periodic_t function);
int msgchan_dispatch(msgchan_t *mc);
int msgchan_create(io_t *in, io_t *out, msgchan_t **pmc);
int msgchan_free(msgchan_t *mc);

#endif
