#include <klone/klone.h>

static const char policy_request[] = "<policy-file-request/>";

static int msgchan_request_hook(request_t *rq, response_t *rs)
{
    const char *ln;
    io_t *out = response_io(rs);
    io_t *cd = NULL;
    
    dbg_err_if(rq == NULL);
    dbg_err_if(rs == NULL);
    dbg_err_if(out == NULL);

    ln = request_get_client_request(rq);
    dbg_err_if(ln == NULL);

    if(strncmp(ln, policy_request, sizeof(policy_request)) == 0)
    {
        /* this will avoid HTTP response */
        warn_err_if(io_codecs_remove(out));

        /* prints out the crossdomain.xml file */
        dbg_err_if(emb_open("/www/crossdomain.xml", &cd));

        dbg_err_if(io_pipe(out, cd) < 0);

        dbg_err_if(io_write(out, "\n\x00", 2) < 0);

        io_free(cd), cd = NULL;

        io_flush(out);

        io_close(out);
    }

    return 0;
err:
    if(cd)
        io_free(cd);
    return ~0;
}

void hooks_setup(void)
{
    crit_err_if(hook_request( msgchan_request_hook ));

err:
    return;
}


