function MessageChannel(host, port, uri)
{
    var max_retries = 10;
    var xs_serv_ip = host;
    var xs_serv_port = port;
    var xs_serv_uri = uri;
    var is_ready = false;
    var retries = max_retries;

    this.pending = 0;

    this.onConnect = function() {} 
    this.onClose = function() {}

    this.send = function(id, data)
    {
        var mc = this;
        var x = xmls;

        // this should give time to the XMLSocket obj to send the data 
        // otherwise a .send() will overwrite previous NOT sent message
        setTimeout(function() { 
            x.send(id + ":" + data.toJSONString());
            mc.pending--;
        }, mc.pending++ * 100);
    }

    this.create_flashdiv = function(id)
    {
        var div = document.createElement('div');

        div.setAttribute('id', id);

        div.style.position = "absolute";
        div.style.width = div.style.height = div.style.left = div.style.top = 0;

        div.innerHTML = "";

        document.body.appendChild(div);
    } 

    this.connect = function (host, port, uri)
    {
        var sock = this;

        /* if the Flash link is not ready yet wait a bit and try again */
        if(!xmls.ready())
        {
            setTimeout(function() { sock.connect(host, port, uri); } , 100);
            return;
        }

        function retry()
        {
            if(retries-- > 0)
                setTimeout(sock.connect(), 3000);
        }

        xmls.onConnect = function(success) 
        {
            if(success)
            {
                rq = "GET " + xs_serv_uri + " HTTP/1.0\n\n";

                xmls.send(rq);

                is_ready = true;
                retries = max_retries;

                // wait for the server ready (ctrl:ready) control message
            } else {
                is_ready = false;
                retry();
            }
        };
        xmls.onClose = function()
        {
            is_ready = false;

            sock.onMessage("onClose", null);

            // reconnect
            retry();
        }
        xmls.onXML = function(msg_json) 
        {
            var msg = eval("(" + msg_json + ")"); 

            if(msg.id == "ctrl" && msg.data == "ready")
                sock.onMessage("onConnect", null); 
            sock.onMessage(msg.id, msg.data);
        }
        xmls.onData = function(msg_json) 
        {
            var msg = eval("(" + msg_json + ")"); 

            if(msg.id == "ctrl" && msg.data == "ready")
                sock.onMessage("onConnect", null); 
            sock.onMessage(msg.id, msg.data);
        }
        if(host)
            xs_serv_ip = host;
        if(port)
        {
            if(port < 1024)
                alert("port must be > 1024!");
            xs_serv_port = port;
        }
        if(uri)
            xs_serv_uri = uri;

        xmls.connect(xs_serv_ip, xs_serv_port);
    }

    this.ready = function ()
    {
        return is_ready;
    }

    var xmls = new XMLSocket;

    this.create_flashdiv("msgchan-div");

    xmls.init("msgchan-div");
}

